diff --git a/web/pgadmin/misc/static/explain/scss/_explain.scss b/web/pgadmin/misc/static/explain/scss/_explain.scss
index 56518d0..ff32fb2 100644
--- a/web/pgadmin/misc/static/explain/scss/_explain.scss
+++ b/web/pgadmin/misc/static/explain/scss/_explain.scss
@@ -49,7 +49,6 @@ div.tab-pane[data-explain-tabpanel=table] {
   td.pga-ex-inclusive-2,
   td.pga-ex-rowsx-2 {
     background-color: $explain-sev-2-bg;
-    color: $explain-sev-2-color;
   }
 
   td.pga-ex-exclusive-3,
diff --git a/web/pgadmin/static/scss/_bootstrap.overrides.scss b/web/pgadmin/static/scss/_bootstrap.overrides.scss
index 1314eb5..bb1a0cc 100644
--- a/web/pgadmin/static/scss/_bootstrap.overrides.scss
+++ b/web/pgadmin/static/scss/_bootstrap.overrides.scss
@@ -167,12 +167,12 @@ legend {
 
 .btn-success[disabled] {
     background-color: $color-success-disabled-bg !important;
-    border-color: $color-success-disabled-bg !important;
+    border-color: $color-success-disabled-border-color !important;
     color: $color-success-disabled-fg !important;
 
     label {
       background-color: $color-success-disabled-bg !important;
-      border-color: $color-success-disabled-bg !important;
+      border-color: $color-success-disabled-border-color !important;
       color: $color-success-disabled-fg !important;
     }
 }
@@ -414,3 +414,7 @@ td.switch-cell > div.toggle {
     overflow-y: auto;
   }
 }
+
+td.pga-ex-exclusive-2, td.pga-ex-inclusive-2 {
+  color: color-yiq($explain-sev-2-bg);
+}
diff --git a/web/pgadmin/static/scss/resources/_default.variables.scss b/web/pgadmin/static/scss/resources/_default.variables.scss
index a854cc3..df115e7 100644
--- a/web/pgadmin/static/scss/resources/_default.variables.scss
+++ b/web/pgadmin/static/scss/resources/_default.variables.scss
@@ -29,6 +29,7 @@ $color-success-light: #D9ECDA !default;
 
 $color-success-disabled-fg: $color-bg !default;
 $color-success-disabled-bg: $color-success !default;
+$color-success-disabled-border-color: $color-success !default;
 $color-success-hover-fg: $white !default;
 
 $color-warning: #eea236 !default;
@@ -257,7 +258,6 @@ $explain-sev-3-bg: #EE8800 !default;
 $explain-sev-4-bg: #880000 !default;
 $explain-sev-3-color: #FFFFFF !default;
 $explain-sev-4-color: #FFFFFF !default;
-$explain-sev-2-color: $black !default;
 
 $dialog-box-shadow: 0 0.5rem 3rem $shadow-base-color;
 
diff --git a/web/pgadmin/static/scss/resources/dark/_theme.variables.scss b/web/pgadmin/static/scss/resources/dark/_theme.variables.scss
index ad85c84..c7d8245 100644
--- a/web/pgadmin/static/scss/resources/dark/_theme.variables.scss
+++ b/web/pgadmin/static/scss/resources/dark/_theme.variables.scss
@@ -81,7 +81,6 @@ $explain-sev-3-bg: #c2812b;
 $explain-sev-4-bg: #880000;
 $explain-sev-3-color: $color-fg;
 $explain-sev-4-color: $color-fg;
-$explain-sev-2-color: $black;
 
 $negative-bg: $color-bg;
 
diff --git a/web/pgadmin/static/scss/resources/high_contrast/_theme.variables.scss b/web/pgadmin/static/scss/resources/high_contrast/_theme.variables.scss
index 18edcc9..e89bd59 100644
--- a/web/pgadmin/static/scss/resources/high_contrast/_theme.variables.scss
+++ b/web/pgadmin/static/scss/resources/high_contrast/_theme.variables.scss
@@ -23,6 +23,7 @@ $color-success-light: #45D48A;
 
 $color-success-disabled-fg: $color-fg;
 $color-success-disabled-bg: $color-bg;
+$color-success-disabled-border-color: $color-fg;
 $color-success-hover-fg: #010B15;
 
 $color-warning: #F4D35E;
@@ -104,7 +105,6 @@ $explain-sev-3-bg: #FFAD65;
 $explain-sev-4-bg: #EE7A55;
 $explain-sev-3-color: #010B15;
 $explain-sev-4-color: #010B15;
-$explain-sev-2-color: #010B15;
 
 $btn-ternary-border: $color-ternary;
 $btn-ternary-hover-bg: #a6b7c8;
diff --git a/web/pgadmin/tools/schema_diff/static/css/schema_diff.css b/web/pgadmin/tools/schema_diff/static/css/schema_diff.css
index b94def0..ef66d23 100644
--- a/web/pgadmin/tools/schema_diff/static/css/schema_diff.css
+++ b/web/pgadmin/tools/schema_diff/static/css/schema_diff.css
@@ -3,19 +3,6 @@
   font-size: 1.3em !important;
 }
 
-.icon-schema-diff-white {
-  display: inline-block;
-  align-content: center;
-  vertical-align: middle;
-  height: 18px;
-  width: 18px;
-  background-size: 20px !important;
-  background-repeat: no-repeat;
-  background-position-x: center;
-  background-position-y: center;
-  background-image: url('../img/compare-white.svg') !important;
-}
-
 .icon-script {
   display: inline-block;
   align-content: center;
diff --git a/web/pgadmin/tools/schema_diff/static/js/schema_diff.backform.js b/web/pgadmin/tools/schema_diff/static/js/schema_diff.backform.js
index 10e7515..77d317a 100644
--- a/web/pgadmin/tools/schema_diff/static/js/schema_diff.backform.js
+++ b/web/pgadmin/tools/schema_diff/static/js/schema_diff.backform.js
@@ -317,7 +317,7 @@ let SchemaDiffHeaderView = Backform.Form.extend({
       <div class="col-6 target row"></div>
       <div class="col-5 target-buttons">
           <div class="action-btns d-flex">
-              <button class="btn btn-primary mr-auto"><i class="icon-schema-diff-white"></i>&nbsp;` + gettext('Compare') + `</button>
+              <button class="btn btn-primary mr-auto"><span class="icon-schema-diff"></span>&nbsp;` + gettext('Compare') + `</button>
               <button id="generate-script" class="btn btn-primary-icon mr-1" disabled><i class="fa fa-file-code-o sql-icon-lg"></i>&nbsp;` + gettext('Generate Script') + `</button>
               <div class="btn-group mr-1" role="group" aria-label="">
                 <button id="btn-filter" type="button" class="btn btn-primary-icon"
diff --git a/web/pgadmin/tools/schema_diff/static/scss/_schema_diff.scss b/web/pgadmin/tools/schema_diff/static/scss/_schema_diff.scss
index 2675591..b31da72 100644
--- a/web/pgadmin/tools/schema_diff/static/scss/_schema_diff.scss
+++ b/web/pgadmin/tools/schema_diff/static/scss/_schema_diff.scss
@@ -24,7 +24,7 @@
   font-size: $tree-font-size;
   .ui-widget-content {
     background-color: $input-bg;
-    color: $schema-diff-color-fg;
+    color: $input-color;
   }
 
   .ui-state-default {
@@ -67,16 +67,20 @@
 
 #schema-diff-grid .different {
   background-color: $schemadiff-diff-row-color !important;
+  color: $schema-diff-color-fg;
 }
 #schema-diff-grid .source {
   background-color: $schemadiff-source-row-color;
+  color: $schema-diff-color-fg;
 }
 #schema-diff-grid .target {
   background-color: $schemadiff-target-row-color !important;
+  color: $schema-diff-color-fg;
 }
 
 #schema-diff-grid .slick-row.active {
     background-color: $table-bg-selected !important;
+    color: $schema-diff-color-fg;
 }
 
 #schema-diff-ddl-comp {